<?php


namespace App\Http\Controllers;



use App\Models\CommunitySchedule;
use App\Models\Order;
use App\Models\Schedule;
use App\Models\SchedulePeriod;
use App\Models\SystemConfig;
use App\Models\TimePeriod;
use Encore\Admin\Admin;
use Illuminate\Support\Facades\DB;
use phpDocumentor\Reflection\DocBlock\Description;

class ScheDuleController  extends Controller
{

    public function getComSchedule()
    {

        $time  = TimePeriod::get(['id','start_time_period','end_time_period']);

        $set_time = request('Schedulingtime');//时间
        $org_id = request('mechanism');//机构
        $docter_id = request('docter_id');//医生


        $set_time = '2020-11-30至2020-12-06';
        $org_id = 2;
        $docter_id = 47;

        if(empty($set_time) || empty($org_id) || empty($docter_id)){
            return json_encode(['status'=>601,'msg'=>'缺少必要参数','data'=>'']);
        } else{
            echo 'what happend';
        }


        $all_time = explode('至',$set_time);
        if(count($all_time) <2){
            return json_encode(['status'=>601,'msg'=>'缺少必要参数','data'=>'']);
        }

        $start_time  = intval(str_replace('-','',$all_time[0]));
        $end_time  = intval(str_replace('-','',$all_time[1]));
//        DB::enableQueryLog();
//        $sche_dule = Schedule::whereBetween('schedule_day',[$start_time,$end_time])
//                                ->where(['docter_id'=>$docter_id])
//                                ->pluck('id')
//                                ->toArray();
//        echo '<pre>';
//        print_r(DB::getQueryLog());
//        echo '</pre>';
        //dd($sche_dule);

        $sche_dule_arr = [
            [
                'date'=>"上午",
                'mondy'=>true,
                'tuesday'=>true,
                'wednesday'=>true,
                'thursday'=>true,
                'friday'=>true,
                'saturday'=>true,
                'sunday'=>true,
            ],
            [
                'date'=>"下午",
                'mondy'=>true,
                'tuesday'=>true,
                'wednesday'=>true,
                'thursday'=>true,
                'friday'=>true,
                'saturday'=>true,
                'sunday'=>true,
            ],
            [
                'date'=>"晚上",
                'mondy'=>true,
                'tuesday'=>true,
                'wednesday'=>true,
                'thursday'=>true,
                'friday'=>true,
                'saturday'=>true,
                'sunday'=>true,
            ]
        ];

        //周字段映射
        $week_arr = ['mondy','tuesday','wednesday','thursday','friday','saturday','sunday'];

        //时段区间id
        $schedule_config = SystemConfig::get('docter_config');
        $mo = TimePeriod::where('start_time_period','>=',$schedule_config['morning_start'])->where('end_time_period','<=',$schedule_config['morning_end'])->pluck('id')->toArray();
        $af = TimePeriod::where('start_time_period','>=',$schedule_config['afternoon_start'])->where('end_time_period','<=',$schedule_config['afternoon_end'])->pluck('id')->toArray();
        $ev = TimePeriod::where('start_time_period','>=',$schedule_config['evening_start'])->where('end_time_period','<=',$schedule_config['evening_end'])->pluck('id')->toArray();
        if(empty($sche_dule)){
            return ['status'=>200,'msg'=>'ok','data'=>['schedule'=>$sche_dule_arr,'org_id'=>$org_id,'docter_id'=>$docter_id]];
        }
        for ($i = $start_time; $i<=$end_time; $i++){
             $j = 0;
             $strtime = "$i";
             $str_time = substr($strtime,0,4).'-'.substr($strtime,4,2).'-'.substr($strtime,6,2);
             //检测上午
            $is_mo_have = SchedulePeriod::whereIn('schedule_id',$sche_dule)->where('schedule_date',$str_time)->whereIn('time_period_id',$mo)->where('organization_id','!=',$org_id)->count();
            if($is_mo_have){
                 $sche_dule_arr[0][$week_arr[$j]] = 'other';
             }
             //检测下午
            $is_af_have = SchedulePeriod::whereIn('schedule_id',$sche_dule)->where('schedule_date',$str_time)->whereIn('time_period_id',$af)->where('organization_id','!=',$org_id)->count();
            if($is_af_have){
                $sche_dule_arr[1][$week_arr[$j]] = 'other';
            }

            //检测晚上
            $is_ev_have = SchedulePeriod::whereIn('schedule_id',$sche_dule)->where('schedule_date',$str_time)->whereIn('time_period_id',$ev)->where('organization_id','!=',$org_id)->count();
            if($is_ev_have){
                $sche_dule_arr[2][$week_arr[$j]] = 'other';
            }
        }
        //  "morning_start" => "09:00"
        //  "morning_end" => "12:00"
        //  "afternoon_start" => "13:00"
        //  "afternoon_end" => "18:00"
        //  "evening_start" => "19:00"
        //  "evening_end" => "20:00"

        $data['docter'] = $sche_dule_arr;
        $data['role'] = 1;
        return  (json_encode(['code'=>200,'msg'=>'ok','data'=>$data]));
    }


    public function setDocChedule()
    {

    }

    public function get_chat_order()
    {
        $org_id = 1;
        $docter_id = 1;

        $list = Order::where(['organization_id'=>$org_id,'docter_id'=>$docter_id,'order_status'=>3])->with('orderUser')->distinct('user_id')->get('user_id');
        foreach ($list as $val){
            $user_list[] = [
                'user_id'=>$val->user_id,
                'avatar'=>$val->orderUser->avatar,
                'name'=>$val->orderUser->nickname,
            ];
        }
        $data['docter_id'] = $docter_id;
        $data['order_list'] = $user_list;
        return  (json_encode(['code'=>200,'msg'=>'ok','data'=>$data]));
    }
}
